# -*- coding: utf-8 -*-

# PUPPy, A Playstation Update Package (PUP) packer/unpacker
# Copyright (C) 2011, Hexodin

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""
Module implementing mainDialog.
"""

import os

from PyQt4.QtGui import QDialog,  QIcon,  QFileDialog, QMessageBox
from PyQt4.QtCore import pyqtSignature

from ui.Ui_puppy import Ui_mainDialog

import pup

__version__ = "1.0"

class mainDialog(QDialog, Ui_mainDialog):
    """
    Class documentation goes here.
    """
    def __init__(self, parent = None):
        """
        Constructor
        """
        QDialog.__init__(self, parent)
        self.setupUi(self)
    
    @pyqtSignature("")
    def on_toolButton_pup_path_clicked(self):
        """
        Open dialog to choose the PUP File.
        """
        self.lineEdit_pup_path.setText(QFileDialog.getOpenFileName(self, u"Open PUP", "",  u"PUP Files (*.PUP)"))
    
    @pyqtSignature("")
    def on_toolButton_pup_directory_clicked(self):
        """
        Open dialog to choose directory.
        """
        self.lineEdit_directory.setText(QFileDialog.getExistingDirectory(self, u"Open Directory", ".",  QFileDialog.ShowDirsOnly))
    
    @pyqtSignature("")
    def on_pushButton_run_clicked(self):
        """
        Run the main code.
        """
        try: PUP = pup.PUP(os.path.join("src", "pup-hmac"))
        except: QMessageBox.warning(self,  "Error!", u"The pup-hmac key was not found.")
        if self.lineEdit_pup_path.text() == '' or self.lineEdit_directory.text() == '': QMessageBox.warning(self,  "Error!", u"You have to inform the PUP Path and the Directory.")
        elif self.radioButton_unpack.isChecked(): 
            try:
                PUP.unpack(self.lineEdit_pup_path.text(),  self.lineEdit_directory.text())
                QMessageBox.warning(self,  "Done!", "Done!\nThe PUP file was unpacked.")
            except: QMessageBox.warning(self,  "Error!", "An error has occurred.\nProbably it's not a PUP File.")
        else:
            try:
                PUP.pack(self.lineEdit_pup_path.text(),  self.lineEdit_directory.text())
                QMessageBox.warning(self,  "Done!", "Done!\nThe PUP file was packed.")
            except: QMessageBox.warning(self,  "Error!", u"An error has occurred.\nThis directory probably don't exist.")      
    
    @pyqtSignature("")
    def on_pushButton_about_clicked(self):
        """
        Show information.
        """
        QMessageBox.about(self, "About PUPPy %s" % __version__,  u"<font size = '5'><b>PUPPy %s</b></font><br />A Playstation Update Package (PUP) packer/unpacker.<br />by Hexodin <hexodin@gmail.com>, 2011<br /><a href = 'http://www.romhacking.trd.br'>Visit FUT!</a>" % __version__)
